package com.madeu.dao.web.webeventpetit;

import jakarta.annotation.PostConstruct;
import org.mybatis.spring.SqlSessionTemplate;
import org.mybatis.spring.support.SqlSessionDaoSupport;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.dao.DataAccessException;
import org.springframework.stereotype.Repository;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Repository
public class WebEventPetitSqlMapDAO extends SqlSessionDaoSupport{

    @Autowired
    private SqlSessionTemplate sqlSessionTemplate;

    @PostConstruct
    void init() {
        setSqlSessionTemplate(sqlSessionTemplate);
    }

    /**
     * 홈페이지 이벤트(쁘띠) 정보 총 갯수 조회 (total count)
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public List<Map<String, Object>> selectTotalWebEventPetitCount(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventPetitSqlMapDAO selectTotalWebEventPetitCount START");
        String sqlId = "WebEventPetit.selectTotalWebEventPetitCount";
        logger.debug("WebEventPetitSqlMapDAO selectTotalWebEventPetitCount END");
        return getSqlSession().selectList(sqlId, paramMap);
    }

    /**
     * 홈페이지 이벤트(쁘띠) 정보 리스트 조회 (List)
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public List<Map<String, Object>> selectListWebEventPetit(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventPetitSqlMapDAO selectListWebEventPetit START");
        String sqlId = "WebEventPetit.selectListWebEventPetit";
        logger.debug("WebEventPetitSqlMapDAO selectListWebEventPetit END");
        return getSqlSession().selectList(sqlId, paramMap);
    }

    /**
     * 홈페이지 이벤트(쁘띠) 정보 조회
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public List<Map<String, Object>> selectWebEventPetit(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventPetitSqlMapDAO selectWebEventPetit START");
        String sqlId = "WebEventPetit.selectWebEventPetit";
        logger.debug("WebEventPetitSqlMapDAO selectWebEventPetit END");
        return getSqlSession().selectList(sqlId, paramMap);
    }

    /**
     * 홈페이지 이벤트(쁘띠) 정보 등록
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public int insertWebEventPetit(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventPetitSqlMapDAO insertWebEventPetit START");
        String sqlId = "WebEventPetit.insertWebEventPetit";
        logger.debug("WebEventPetitSqlMapDAO insertWebEventPetit END");
        return getSqlSession().insert(sqlId, paramMap);
    }
    
    /**
     * 홈페이지 이벤트(쁘띠) 파일 정보 등록
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public int insertWebEventPetitContentFile(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventPetitSqlMapDAO insertWebEventPetitContentFile START");
        String sqlId = "WebEventPetit.insertWebEventPetitContentFile";
        logger.debug("WebEventPetitSqlMapDAO insertWebEventPetitContentFile END");
        return getSqlSession().insert(sqlId, paramMap);
    }
    
    /**
     * 홈페이지 이벤트(쁘띠) 파일 정보 등록
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public int insertWebEventPetitThumbnailFile(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventPetitSqlMapDAO insertWebEventPetitThumbnailFile START");
        String sqlId = "WebEventPetit.insertWebEventPetitThumbnailFile";
        logger.debug("WebEventPetitSqlMapDAO insertWebEventPetitThumbnailFile END");
        return getSqlSession().insert(sqlId, paramMap);
    }
    
    /**
     * 홈페이지 이벤트(쁘띠) 시술 정보 등록
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public int insertWebEventListPetit(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventPetitSqlMapDAO insertWebEventListPetit START");
        String sqlId = "WebEventPetit.insertWebEventListPetit";
        logger.debug("WebEventPetitSqlMapDAO insertWebEventListPetit END");
        return getSqlSession().insert(sqlId, paramMap);
    }
    
    /**
     * 홈페이지 이벤트(쁘띠) 시술 정보 수정
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public int updateWebEventListPetit(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventPetitSqlMapDAO updateWebEventListPetit START");
        String sqlId = "WebEventPetit.updateWebEventListPetit";
        logger.debug("WebEventPetitSqlMapDAO updateWebEventListPetit END");
        return getSqlSession().update(sqlId, paramMap);
    }

    /**
     * 홈페이지 이벤트(쁘띠) 정보 수정
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public int updateWebEventPetit(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventPetitSqlMapDAO updateWebEventPetit START");
        String sqlId = "WebEventPetit.updateWebEventPetit";
        logger.debug("WebEventPetitSqlMapDAO updateWebEventPetit END");
        return getSqlSession().update(sqlId, paramMap);
    }

    /**
     * 홈페이지 이벤트(쁘띠) 정보 삭제
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public int deleteWebEventPetit(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventPetitSqlMapDAO deleteWebEventPetit START");
        String sqlId = "WebEventPetit.deleteWebEventPetit";
        logger.debug("WebEventPetitSqlMapDAO deleteWebEventPetit END");
        return getSqlSession().update(sqlId, paramMap);
    }
    
    /**
     * 시술 정보 총 갯수 조회 (total count)
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public Integer selectTotalEventCount(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventPetitSqlMapDAO selectTotalEventCount START");
        String sqlId = "WebEventPetit.selectTotalEventCount";
        logger.debug("WebEventPetitSqlMapDAO selectTotalEventCount END");
        return getSqlSession().selectOne(sqlId, paramMap);
    }
    /**
     * 시술 정보 리스트 조회 (List)
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public List<Map<String, Object>> selectListEvent(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventPetitSqlMapDAO selectListEvent START");
        String sqlId = "WebEventPetit.selectListEvent";
        logger.debug("WebEventPetitSqlMapDAO selectListEvent END");
        return getSqlSession().selectList(sqlId, paramMap);
    }
    /**
     * 시술 카테고리 정보 리스트 조회 (List)
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public List<Map<String, Object>> selectWebEventPetitCategory(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventPetitSqlMapDAO selectWebEventPetitCategory START");
        String sqlId = "WebEventPetit.selectListEventCategory";
        logger.debug("WebEventPetitSqlMapDAO selectWebEventPetitCategory END");
        return getSqlSession().selectList(sqlId, paramMap);
    }
    
    /**
     * 시술 카테고리 정보 시술리스트 조회 (List)
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public List<Map<String, Object>> selectWebEventListPetit(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebEventPetitSqlMapDAO selectWebEventListPetit START");
        String sqlId = "WebEventPetit.selectWebEventListPetit";
        logger.debug("WebEventPetitSqlMapDAO selectWebEventListPetit END");
        return getSqlSession().selectList(sqlId, paramMap);
    }
    
}
